# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20241101

from __future__ import absolute_import

from .agreement import Agreement
from .agreement_record import AgreementRecord
from .agreement_record_collection import AgreementRecordCollection
from .agreement_record_summary import AgreementRecordSummary
from .applicable_patch_collection import ApplicablePatchCollection
from .applicable_patch_summary import ApplicablePatchSummary
from .backup import Backup
from .backup_collection import BackupCollection
from .backup_content import BackupContent
from .backup_summary import BackupSummary
from .backup_to_restore import BackupToRestore
from .binary_backup_content import BinaryBackupContent
from .change_wls_domain_compartment_details import ChangeWlsDomainCompartmentDetails
from .configuration import Configuration
from .create_agreement_record_details import CreateAgreementRecordDetails
from .default_error import DefaultError
from .install_latest_patches_on_wls_domain_details import InstallLatestPatchesOnWlsDomainDetails
from .installed_patch_collection import InstalledPatchCollection
from .installed_patch_summary import InstalledPatchSummary
from .managed_instance import ManagedInstance
from .managed_instance_collection import ManagedInstanceCollection
from .managed_instance_configuration import ManagedInstanceConfiguration
from .managed_instance_summary import ManagedInstanceSummary
from .middleware_backup_patch import MiddlewareBackupPatch
from .middleware_binary_backup_content import MiddlewareBinaryBackupContent
from .patch import Patch
from .required_policy_collection import RequiredPolicyCollection
from .required_policy_summary import RequiredPolicySummary
from .resource_inventory import ResourceInventory
from .restart_wls_domain_details import RestartWlsDomainDetails
from .restore_wls_domain_details import RestoreWlsDomainDetails
from .scan_result_collection import ScanResultCollection
from .scan_result_summary import ScanResultSummary
from .server import Server
from .server_collection import ServerCollection
from .server_summary import ServerSummary
from .server_to_restore import ServerToRestore
from .set_restart_order_details import SetRestartOrderDetails
from .set_restart_order_server_collection import SetRestartOrderServerCollection
from .set_restart_order_server_summary import SetRestartOrderServerSummary
from .stop_wls_domain_details import StopWlsDomainDetails
from .update_configuration_details import UpdateConfigurationDetails
from .update_managed_instance_configuration_details import UpdateManagedInstanceConfigurationDetails
from .update_managed_instance_details import UpdateManagedInstanceDetails
from .update_wls_domain_configuration_details import UpdateWlsDomainConfigurationDetails
from .update_wls_domain_credential_details import UpdateWlsDomainCredentialDetails
from .update_wls_domain_details import UpdateWlsDomainDetails
from .wls_domain import WlsDomain
from .wls_domain_collection import WlsDomainCollection
from .wls_domain_configuration import WlsDomainConfiguration
from .wls_domain_credential import WlsDomainCredential
from .wls_domain_credential_collection import WlsDomainCredentialCollection
from .wls_domain_credential_summary import WlsDomainCredentialSummary
from .wls_domain_summary import WlsDomainSummary
from .work_request import WorkRequest
from .work_request_error import WorkRequestError
from .work_request_error_collection import WorkRequestErrorCollection
from .work_request_log_entry import WorkRequestLogEntry
from .work_request_log_entry_collection import WorkRequestLogEntryCollection
from .work_request_resource import WorkRequestResource
from .work_request_summary import WorkRequestSummary
from .work_request_summary_collection import WorkRequestSummaryCollection

# Maps type names to classes for wlms services.
wlms_type_mapping = {
    "Agreement": Agreement,
    "AgreementRecord": AgreementRecord,
    "AgreementRecordCollection": AgreementRecordCollection,
    "AgreementRecordSummary": AgreementRecordSummary,
    "ApplicablePatchCollection": ApplicablePatchCollection,
    "ApplicablePatchSummary": ApplicablePatchSummary,
    "Backup": Backup,
    "BackupCollection": BackupCollection,
    "BackupContent": BackupContent,
    "BackupSummary": BackupSummary,
    "BackupToRestore": BackupToRestore,
    "BinaryBackupContent": BinaryBackupContent,
    "ChangeWlsDomainCompartmentDetails": ChangeWlsDomainCompartmentDetails,
    "Configuration": Configuration,
    "CreateAgreementRecordDetails": CreateAgreementRecordDetails,
    "DefaultError": DefaultError,
    "InstallLatestPatchesOnWlsDomainDetails": InstallLatestPatchesOnWlsDomainDetails,
    "InstalledPatchCollection": InstalledPatchCollection,
    "InstalledPatchSummary": InstalledPatchSummary,
    "ManagedInstance": ManagedInstance,
    "ManagedInstanceCollection": ManagedInstanceCollection,
    "ManagedInstanceConfiguration": ManagedInstanceConfiguration,
    "ManagedInstanceSummary": ManagedInstanceSummary,
    "MiddlewareBackupPatch": MiddlewareBackupPatch,
    "MiddlewareBinaryBackupContent": MiddlewareBinaryBackupContent,
    "Patch": Patch,
    "RequiredPolicyCollection": RequiredPolicyCollection,
    "RequiredPolicySummary": RequiredPolicySummary,
    "ResourceInventory": ResourceInventory,
    "RestartWlsDomainDetails": RestartWlsDomainDetails,
    "RestoreWlsDomainDetails": RestoreWlsDomainDetails,
    "ScanResultCollection": ScanResultCollection,
    "ScanResultSummary": ScanResultSummary,
    "Server": Server,
    "ServerCollection": ServerCollection,
    "ServerSummary": ServerSummary,
    "ServerToRestore": ServerToRestore,
    "SetRestartOrderDetails": SetRestartOrderDetails,
    "SetRestartOrderServerCollection": SetRestartOrderServerCollection,
    "SetRestartOrderServerSummary": SetRestartOrderServerSummary,
    "StopWlsDomainDetails": StopWlsDomainDetails,
    "UpdateConfigurationDetails": UpdateConfigurationDetails,
    "UpdateManagedInstanceConfigurationDetails": UpdateManagedInstanceConfigurationDetails,
    "UpdateManagedInstanceDetails": UpdateManagedInstanceDetails,
    "UpdateWlsDomainConfigurationDetails": UpdateWlsDomainConfigurationDetails,
    "UpdateWlsDomainCredentialDetails": UpdateWlsDomainCredentialDetails,
    "UpdateWlsDomainDetails": UpdateWlsDomainDetails,
    "WlsDomain": WlsDomain,
    "WlsDomainCollection": WlsDomainCollection,
    "WlsDomainConfiguration": WlsDomainConfiguration,
    "WlsDomainCredential": WlsDomainCredential,
    "WlsDomainCredentialCollection": WlsDomainCredentialCollection,
    "WlsDomainCredentialSummary": WlsDomainCredentialSummary,
    "WlsDomainSummary": WlsDomainSummary,
    "WorkRequest": WorkRequest,
    "WorkRequestError": WorkRequestError,
    "WorkRequestErrorCollection": WorkRequestErrorCollection,
    "WorkRequestLogEntry": WorkRequestLogEntry,
    "WorkRequestLogEntryCollection": WorkRequestLogEntryCollection,
    "WorkRequestResource": WorkRequestResource,
    "WorkRequestSummary": WorkRequestSummary,
    "WorkRequestSummaryCollection": WorkRequestSummaryCollection
}
